package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.QualificationAttributeDefinitionResource;
import de.humance.eco.profile.model.QualificationAttributeDefinitionResourceModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the QualificationAttributeDefinitionResource service. Represents a row in the &quot;Profile_QualificationAttributeDefinitionResource&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationAttributeDefinitionResourceModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationAttributeDefinitionResourceImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationAttributeDefinitionResourceImpl
 * @see de.humance.eco.profile.model.QualificationAttributeDefinitionResource
 * @see de.humance.eco.profile.model.QualificationAttributeDefinitionResourceModel
 * @generated
 */
public class QualificationAttributeDefinitionResourceModelImpl
    extends BaseModelImpl<QualificationAttributeDefinitionResource>
    implements QualificationAttributeDefinitionResourceModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification attribute definition resource model instance should use the {@link de.humance.eco.profile.model.QualificationAttributeDefinitionResource} interface instead.
     */
    public static final String TABLE_NAME = "Profile_QualificationAttributeDefinitionResource";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationAttributeDefinitionResourceId", Types.BIGINT },
            { "qualificationAttributeDefinitionId", Types.BIGINT },
            { "country", Types.VARCHAR },
            { "language", Types.VARCHAR },
            { "title", Types.VARCHAR },
            { "unit", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_QualificationAttributeDefinitionResource (qualificationAttributeDefinitionResourceId LONG not null primary key,qualificationAttributeDefinitionId LONG,country VARCHAR(75) null,language VARCHAR(75) null,title VARCHAR(500) null,unit VARCHAR(255) null)";
    public static final String TABLE_SQL_DROP = "drop table Profile_QualificationAttributeDefinitionResource";
    public static final String ORDER_BY_JPQL = " ORDER BY qualificationAttributeDefinitionResource.qualificationAttributeDefinitionId ASC, qualificationAttributeDefinitionResource.country ASC, qualificationAttributeDefinitionResource.language ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_QualificationAttributeDefinitionResource.qualificationAttributeDefinitionId ASC, Profile_QualificationAttributeDefinitionResource.country ASC, Profile_QualificationAttributeDefinitionResource.language ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.QualificationAttributeDefinitionResource"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.QualificationAttributeDefinitionResource"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.QualificationAttributeDefinitionResource"),
            true);
    public static long COUNTRY_COLUMN_BITMASK = 1L;
    public static long LANGUAGE_COLUMN_BITMASK = 2L;
    public static long QUALIFICATIONATTRIBUTEDEFINITIONID_COLUMN_BITMASK = 4L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.QualificationAttributeDefinitionResource"));
    private static ClassLoader _classLoader = QualificationAttributeDefinitionResource.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            QualificationAttributeDefinitionResource.class
        };
    private long _qualificationAttributeDefinitionResourceId;
    private long _qualificationAttributeDefinitionId;
    private long _originalQualificationAttributeDefinitionId;
    private boolean _setOriginalQualificationAttributeDefinitionId;
    private String _country;
    private String _originalCountry;
    private String _language;
    private String _originalLanguage;
    private String _title;
    private String _unit;
    private long _columnBitmask;
    private QualificationAttributeDefinitionResource _escapedModel;

    public QualificationAttributeDefinitionResourceModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationAttributeDefinitionResourceId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationAttributeDefinitionResourceId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationAttributeDefinitionResourceId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return QualificationAttributeDefinitionResource.class;
    }

    @Override
    public String getModelClassName() {
        return QualificationAttributeDefinitionResource.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationAttributeDefinitionResourceId",
            getQualificationAttributeDefinitionResourceId());
        attributes.put("qualificationAttributeDefinitionId",
            getQualificationAttributeDefinitionId());
        attributes.put("country", getCountry());
        attributes.put("language", getLanguage());
        attributes.put("title", getTitle());
        attributes.put("unit", getUnit());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationAttributeDefinitionResourceId = (Long) attributes.get(
                "qualificationAttributeDefinitionResourceId");

        if (qualificationAttributeDefinitionResourceId != null) {
            setQualificationAttributeDefinitionResourceId(qualificationAttributeDefinitionResourceId);
        }

        Long qualificationAttributeDefinitionId = (Long) attributes.get(
                "qualificationAttributeDefinitionId");

        if (qualificationAttributeDefinitionId != null) {
            setQualificationAttributeDefinitionId(qualificationAttributeDefinitionId);
        }

        String country = (String) attributes.get("country");

        if (country != null) {
            setCountry(country);
        }

        String language = (String) attributes.get("language");

        if (language != null) {
            setLanguage(language);
        }

        String title = (String) attributes.get("title");

        if (title != null) {
            setTitle(title);
        }

        String unit = (String) attributes.get("unit");

        if (unit != null) {
            setUnit(unit);
        }
    }

    @Override
    public long getQualificationAttributeDefinitionResourceId() {
        return _qualificationAttributeDefinitionResourceId;
    }

    @Override
    public void setQualificationAttributeDefinitionResourceId(
        long qualificationAttributeDefinitionResourceId) {
        _qualificationAttributeDefinitionResourceId = qualificationAttributeDefinitionResourceId;
    }

    @Override
    public long getQualificationAttributeDefinitionId() {
        return _qualificationAttributeDefinitionId;
    }

    @Override
    public void setQualificationAttributeDefinitionId(
        long qualificationAttributeDefinitionId) {
        _columnBitmask = -1L;

        if (!_setOriginalQualificationAttributeDefinitionId) {
            _setOriginalQualificationAttributeDefinitionId = true;

            _originalQualificationAttributeDefinitionId = _qualificationAttributeDefinitionId;
        }

        _qualificationAttributeDefinitionId = qualificationAttributeDefinitionId;
    }

    public long getOriginalQualificationAttributeDefinitionId() {
        return _originalQualificationAttributeDefinitionId;
    }

    @Override
    public String getCountry() {
        if (_country == null) {
            return StringPool.BLANK;
        } else {
            return _country;
        }
    }

    @Override
    public void setCountry(String country) {
        _columnBitmask = -1L;

        if (_originalCountry == null) {
            _originalCountry = _country;
        }

        _country = country;
    }

    public String getOriginalCountry() {
        return GetterUtil.getString(_originalCountry);
    }

    @Override
    public String getLanguage() {
        if (_language == null) {
            return StringPool.BLANK;
        } else {
            return _language;
        }
    }

    @Override
    public void setLanguage(String language) {
        _columnBitmask = -1L;

        if (_originalLanguage == null) {
            _originalLanguage = _language;
        }

        _language = language;
    }

    public String getOriginalLanguage() {
        return GetterUtil.getString(_originalLanguage);
    }

    @Override
    public String getTitle() {
        if (_title == null) {
            return StringPool.BLANK;
        } else {
            return _title;
        }
    }

    @Override
    public void setTitle(String title) {
        _title = title;
    }

    @Override
    public String getUnit() {
        if (_unit == null) {
            return StringPool.BLANK;
        } else {
            return _unit;
        }
    }

    @Override
    public void setUnit(String unit) {
        _unit = unit;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            QualificationAttributeDefinitionResource.class.getName(),
            getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public QualificationAttributeDefinitionResource toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (QualificationAttributeDefinitionResource) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationAttributeDefinitionResourceImpl qualificationAttributeDefinitionResourceImpl =
            new QualificationAttributeDefinitionResourceImpl();

        qualificationAttributeDefinitionResourceImpl.setQualificationAttributeDefinitionResourceId(getQualificationAttributeDefinitionResourceId());
        qualificationAttributeDefinitionResourceImpl.setQualificationAttributeDefinitionId(getQualificationAttributeDefinitionId());
        qualificationAttributeDefinitionResourceImpl.setCountry(getCountry());
        qualificationAttributeDefinitionResourceImpl.setLanguage(getLanguage());
        qualificationAttributeDefinitionResourceImpl.setTitle(getTitle());
        qualificationAttributeDefinitionResourceImpl.setUnit(getUnit());

        qualificationAttributeDefinitionResourceImpl.resetOriginalValues();

        return qualificationAttributeDefinitionResourceImpl;
    }

    @Override
    public int compareTo(
        QualificationAttributeDefinitionResource qualificationAttributeDefinitionResource) {
        int value = 0;

        if (getQualificationAttributeDefinitionId() < qualificationAttributeDefinitionResource.getQualificationAttributeDefinitionId()) {
            value = -1;
        } else if (getQualificationAttributeDefinitionId() > qualificationAttributeDefinitionResource.getQualificationAttributeDefinitionId()) {
            value = 1;
        } else {
            value = 0;
        }

        if (value != 0) {
            return value;
        }

        value = getCountry()
                    .compareToIgnoreCase(qualificationAttributeDefinitionResource.getCountry());

        if (value != 0) {
            return value;
        }

        value = getLanguage()
                    .compareToIgnoreCase(qualificationAttributeDefinitionResource.getLanguage());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof QualificationAttributeDefinitionResource)) {
            return false;
        }

        QualificationAttributeDefinitionResource qualificationAttributeDefinitionResource =
            (QualificationAttributeDefinitionResource) obj;

        long primaryKey = qualificationAttributeDefinitionResource.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationAttributeDefinitionResourceModelImpl qualificationAttributeDefinitionResourceModelImpl =
            this;

        qualificationAttributeDefinitionResourceModelImpl._originalQualificationAttributeDefinitionId = qualificationAttributeDefinitionResourceModelImpl._qualificationAttributeDefinitionId;

        qualificationAttributeDefinitionResourceModelImpl._setOriginalQualificationAttributeDefinitionId = false;

        qualificationAttributeDefinitionResourceModelImpl._originalCountry = qualificationAttributeDefinitionResourceModelImpl._country;

        qualificationAttributeDefinitionResourceModelImpl._originalLanguage = qualificationAttributeDefinitionResourceModelImpl._language;

        qualificationAttributeDefinitionResourceModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<QualificationAttributeDefinitionResource> toCacheModel() {
        QualificationAttributeDefinitionResourceCacheModel qualificationAttributeDefinitionResourceCacheModel =
            new QualificationAttributeDefinitionResourceCacheModel();

        qualificationAttributeDefinitionResourceCacheModel.qualificationAttributeDefinitionResourceId = getQualificationAttributeDefinitionResourceId();

        qualificationAttributeDefinitionResourceCacheModel.qualificationAttributeDefinitionId = getQualificationAttributeDefinitionId();

        qualificationAttributeDefinitionResourceCacheModel.country = getCountry();

        String country = qualificationAttributeDefinitionResourceCacheModel.country;

        if ((country != null) && (country.length() == 0)) {
            qualificationAttributeDefinitionResourceCacheModel.country = null;
        }

        qualificationAttributeDefinitionResourceCacheModel.language = getLanguage();

        String language = qualificationAttributeDefinitionResourceCacheModel.language;

        if ((language != null) && (language.length() == 0)) {
            qualificationAttributeDefinitionResourceCacheModel.language = null;
        }

        qualificationAttributeDefinitionResourceCacheModel.title = getTitle();

        String title = qualificationAttributeDefinitionResourceCacheModel.title;

        if ((title != null) && (title.length() == 0)) {
            qualificationAttributeDefinitionResourceCacheModel.title = null;
        }

        qualificationAttributeDefinitionResourceCacheModel.unit = getUnit();

        String unit = qualificationAttributeDefinitionResourceCacheModel.unit;

        if ((unit != null) && (unit.length() == 0)) {
            qualificationAttributeDefinitionResourceCacheModel.unit = null;
        }

        return qualificationAttributeDefinitionResourceCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(13);

        sb.append("{qualificationAttributeDefinitionResourceId=");
        sb.append(getQualificationAttributeDefinitionResourceId());
        sb.append(", qualificationAttributeDefinitionId=");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append(", country=");
        sb.append(getCountry());
        sb.append(", language=");
        sb.append(getLanguage());
        sb.append(", title=");
        sb.append(getTitle());
        sb.append(", unit=");
        sb.append(getUnit());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(22);

        sb.append("<model><model-name>");
        sb.append(
            "de.humance.eco.profile.model.QualificationAttributeDefinitionResource");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationAttributeDefinitionResourceId</column-name><column-value><![CDATA[");
        sb.append(getQualificationAttributeDefinitionResourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>qualificationAttributeDefinitionId</column-name><column-value><![CDATA[");
        sb.append(getQualificationAttributeDefinitionId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>country</column-name><column-value><![CDATA[");
        sb.append(getCountry());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>language</column-name><column-value><![CDATA[");
        sb.append(getLanguage());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>title</column-name><column-value><![CDATA[");
        sb.append(getTitle());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>unit</column-name><column-value><![CDATA[");
        sb.append(getUnit());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
